import csv
from time import sleep

from data.sig_ref import SIGRef
from providers.sigrefdata.file_download_sig_ref_data_provider import FileDownloadSIGRefDataProvider


class WWBOTA(FileDownloadSIGRefDataProvider):
    """SIG ref data provider for Worldwide Bunkers on the Air"""

    POLL_INTERVAL_DAYS = 30
    SIG = "WWBOTA"
    DATA_URL = "https://api.wwbota.org/bunkers/?format=CSV"

    def __init__(self, provider_config):
        super().__init__(self.SIG, provider_config, self.DATA_URL, self.POLL_INTERVAL_DAYS)

    def _http_response_to_data(self, http_response):
        new_data = []
        for row in csv.DictReader(http_response.content.decode("utf-8-sig").splitlines()):
            ref_id = row["Reference"]
            new_data.append(SIGRef(sig=self.SIG, id=ref_id, name=row["Name"] if "Name" in row else None,
                                      ref_type="Bunker",
                                      url="https://bunkerwiki.org/?s=" + ref_id if ref_id.startswith("B/G") else None,
                                      grid=row["Locator"] if "Locator" in row and row["Locator"] != "" else None,
                                      latitude=float(row["Lat"]) if "Lat" in row and row["Lat"] != "" else None,
                                      longitude=float(row["Long"]) if "Long" in row and row["Long"] != "" else None))

            # Bail out if a stop has been requested, i.e. the program is shutting down - no need to parse the rest of
            # the data in this case
            if self._stop_event.is_set():
                break

            # Very short pause. This will extend the time to handle sig refs by a few seconds but will ensure some time
            # is available for other threads e.g. the web server.
            sleep(0.001)

        return new_data
